
package com.alidns.flutter;

import android.app.Application;
import com.alibaba.pdns.DNSResolver;
import io.flutter.view.FlutterMain;

public class DnsCacheApplication extends Application {

    private String accountID = "9999"; // 可以更换成您的accountID   10001
    private static final String TAOBAO_URL = "www.taobao.com";
    private static final String DOUYIN_URL = "www.douyin.com";
    private static final int CACHE_MAX_NUMBER = 100;  //缓存的域名最大个数
    private static final int MAX_NEGATIVE_CACHE = 30; //设置否定缓存最大TTL时间默认为30秒

    @Override
    public void onCreate() {
        super.onCreate();
        FlutterMain.startInitialization(this); //在这个位置添加这一行很关键
        DNSResolver.Init(this, accountID);
        DNSResolver.setEnableShort(false);
        DNSResolver.setEnableIPv6(false);
        DNSResolver.setEnableCache(true); //默认开启使用缓存
        DNSResolver.setEnableSpeedTest(true); //默认不开启IP测速
        DNSResolver.setMaxNegativeCache(MAX_NEGATIVE_CACHE);
        DNSResolver.setSchemaType(DNSResolver.HTTP);
        DNSResolver.setSpeedPort(DNSResolver.PORT_80);//设置ip测量socket检测的端口号，默认80端口
        DNSResolver.getInstance().setMaxCacheSize(CACHE_MAX_NUMBER);
        DNSResolver.getInstance().preLoadDomains(DNSResolver.QTYPE_IPV4,new String[]{TAOBAO_URL, DOUYIN_URL});
    }
}

