package com.alidns.flutter;
/**
 * @author : zhangmin
 * @data : 2021/8/18 14:28
 * @Description :
 */

import android.os.Bundle;
import android.widget.Toast;

import com.alibaba.pdns.DNSResolver;

import io.flutter.app.FlutterActivity;
import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel;


public class MainActivity extends FlutterActivity {

    //这个跟flutter的通道名称保持一直
    private static final String CHANNEL = "samples.flutter.io/getIP";
    //定义flutter端调用Android原生方法的channelMethod
    private static final String channelMethod = "getIP";
    //flutter对Android端的传参
    private static final String hostArgument = "host";
    //初始化阿里云公共DNS Android SDK中提供的DNSResolver对象
    private DNSResolver dnsResolver = null;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        //初始化DNSResolver
        dnsResolver = DNSResolver.getInstance();

        new MethodChannel(getFlutterView(), CHANNEL).setMethodCallHandler(
                new MethodChannel.MethodCallHandler() {
                    @Override
                    public void onMethodCall(MethodCall methodCall, MethodChannel.Result result) {
                        //这里是判断是不是调getIP方法，因为所有的方法都走这里
                        if (methodCall.method.equals(channelMethod)) {
                            if (methodCall.hasArgument(hostArgument)) {
                                try{
                                    //取出从flutter端传递的host参数
                                    String resolverName = methodCall.argument(hostArgument);
                                    String ip = dnsResolver.getIPV4ByHost(resolverName);
                                    if (ip != null) {
                                        result.success(ip);
                                        Toast.makeText(MainActivity.this, "调用Android原生域名解析成功!", Toast.LENGTH_SHORT).show();
                                    } else {
                                        result.success(resolverName);
                                    }
                                }catch (Exception e){
                                    e.printStackTrace();
                                }
                            }
                        }
                    }
                }
        );
    }

}

