import 'dart:async';
import 'dart:convert';
import 'dart:io';
import 'package:flutter/material.dart';
import 'package:flutter/services.dart';
import 'CustomHttpsProxy.dart';

void main() => runApp(MyApp());
class MyApp extends StatefulWidget {
  // This widget is the root of your application.
  @override
  State<StatefulWidget> createState() {
    // TODO: implement createState
    return MyAppState();
  }
}



class MyAppState extends State<MyApp> {

  static const platform = const MethodChannel('samples.flutter.io/getIP');
  String _getIP = '点我获取域名解析IP';

// 我们调用通道上的方法，指定通过字符串标识符调用方法。
// 该调用可能失败(平台不支持平台API，例如在模拟器中运行时)，
// 所以我们将invokeMethod调用包装在try-catch语句中
  Future<Null> _getResolverIP() async {
    //网络请求
     runPoxyRequest();

    //UI显示域名解析结果
    String getIP;
    try {
      // final String result = await platform.invokeMethod('getIP');
      final String result = await platform.invokeMethod(
          'getIP', {'host': 'www.douyin.com'});
      getIP = '解析IP $result';
    } on PlatformException catch (e) {
      getIP = "Failed to get ip: '${e.message}'.";
    }
    // 在setState中来更新用户界面状态
    setState(() {
      _getIP = getIP;
    });
  }
  void runPoxyRequest() async {
    var proxy = CustomHttpsProxy();
    final result = await proxy.init();
    print('proxy established： ${result != null}');
    await doHttpGet();
    proxy.close();
  }
  Future doHttpGet() async {
    var httpClient = HttpClient();
    httpClient.findProxy = (uri) => 'PROXY localhost:4041';
    var request = await httpClient.getUrl(Uri.parse('https://www.douyin.com'));
    var response = await request.close();
    //读取响应内容
    var responseBody = await response.transform(Utf8Decoder()).join();
    print(responseBody);
  }
// 我们在build创建包含一个小字体显示当前获取的IP
// 和一个用于刷新值的按钮的用户界面。
  @override
  Widget build(BuildContext context) {
    return MaterialApp(
        title: 'FlutterDNS Demo',
        theme: ThemeData(
          primarySwatch: Colors.blue,
        ),
        home: Scaffold(
          appBar: AppBar(title: Text("Flutter场景下使用阿里云公共DNS SDK"),),
          body: Center(

              child: new Column(
                children: <Widget>[
                  RaisedButton(
                    onPressed: (){_getResolverIP();},
                    child: Text('get current IP'),
                  ),
                  Text(_getIP),
                ],
              )
          ),
        )
    );
  }
}

